searchNodes=[{"doc":"A generic behaviour to implement Pub/Sub Clients for BroadwayCloudPubSub.Producer . This module defines callbacks to normalize options and receive messages from a Cloud Pub/Sub topic. Modules that implement this behaviour should be passed as the :client option from BroadwayCloudPubSub.Producer .","ref":"BroadwayCloudPubSub.Client.html","title":"BroadwayCloudPubSub.Client","type":"behaviour"},{"doc":"Dispatches an acknowledge request.","ref":"BroadwayCloudPubSub.Client.html#c:acknowledge/2","title":"BroadwayCloudPubSub.Client.acknowledge/2","type":"callback"},{"doc":"","ref":"BroadwayCloudPubSub.Client.html#c:init/1","title":"BroadwayCloudPubSub.Client.init/1","type":"callback"},{"doc":"Invoked once by BroadwayCloudPubSub.Producer during Broadway.start_link/2 . The goal of this task is to manipulate the producer options, if necessary at all, and introduce any new child specs that will be started in Broadway's supervision tree.","ref":"BroadwayCloudPubSub.Client.html#c:prepare_to_connect/2","title":"BroadwayCloudPubSub.Client.prepare_to_connect/2","type":"callback"},{"doc":"Dispatches a modifyAckDeadline request.","ref":"BroadwayCloudPubSub.Client.html#c:put_deadline/3","title":"BroadwayCloudPubSub.Client.put_deadline/3","type":"callback"},{"doc":"Dispatches a pull request.","ref":"BroadwayCloudPubSub.Client.html#c:receive_messages/3","title":"BroadwayCloudPubSub.Client.receive_messages/3","type":"callback"},{"doc":"The amount of time (in seconds) before Pub/Sub should reschedule a message.","ref":"BroadwayCloudPubSub.Client.html#t:ack_deadline/0","title":"BroadwayCloudPubSub.Client.ack_deadline/0","type":"type"},{"doc":"The ackId returned by Pub/Sub to be used when acknowledging a message.","ref":"BroadwayCloudPubSub.Client.html#t:ack_id/0","title":"BroadwayCloudPubSub.Client.ack_id/0","type":"type"},{"doc":"A list of ackId strings.","ref":"BroadwayCloudPubSub.Client.html#t:ack_ids/0","title":"BroadwayCloudPubSub.Client.ack_ids/0","type":"type"},{"doc":"A list of Broadway.Message structs.","ref":"BroadwayCloudPubSub.Client.html#t:messages/0","title":"BroadwayCloudPubSub.Client.messages/0","type":"type"},{"doc":"A GenStage producer that continuously receives messages from a Google Cloud Pub/Sub topic and acknowledges them after being successfully processed. By default this producer uses BroadwayCloudPubSub.PullClient to talk to Cloud Pub/Sub, but you can provide your client by implementing the BroadwayCloudPubSub.Client behaviour. For a quick getting started on using Broadway with Cloud Pub/Sub, please see the Google Cloud Pub/Sub Guide . Options Aside from :receive_interval and :client which are generic and apply to all producers (regardless of the client implementation), all other options are specific to BroadwayCloudPubSub.PullClient , which is the default client. :client - A module that implements the BroadwayCloudPubSub.Client behaviour. This module is responsible for fetching and acknowledging the messages. Pay attention that all options passed to the producer will be forwarded to the client. It's up to the client to normalize the options it needs. The default value is BroadwayCloudPubSub.PullClient . :subscription - Required. The name of the subscription, including the project. For example, if you project is named &quot;my-project&quot; and your subscription is named &quot;my-subscription&quot; , then your subscription name is &quot;projects/my-project/subscriptions/my-subscription&quot; . :max_number_of_messages - The maximum number of messages to be fetched per request. The default value is 10 . :on_failure - Configures the acking behaviour for failed messages. See the &quot;Acknowledgements&quot; section below for all the possible values. This option can also be changed for each message through Broadway.Message.configure_ack/2 . The default value is :noop . :on_success - Configures the acking behaviour for successful messages. See the &quot;Acknowledgements&quot; section below for all the possible values. This option can also be changed for each message through Broadway.Message.configure_ack/2 . The default value is :ack . :receive_interval - The duration (in milliseconds) for which the producer waits before making a request for more messages. The default value is 5000 . :receive_timeout - The maximum time (in milliseconds) to wait for a response before the pull client returns an error. The default value is :infinity . :scope - A string representing the scope or scopes to use when fetching an access token. Note that this option only applies to the default token generator. The default value is &quot;https://www.googleapis.com/auth/pubsub&quot; . :token_generator - An MFArgs tuple that will be called before each request to fetch an authentication token. It should return {:ok, String.t()} | {:error, any()} . By default this will invoke Goth.Token.for_scope/1 with &quot;https://www.googleapis.com/auth/pubsub&quot; . See the &quot;Custom token generator&quot; section below for more information. :base_url - The base URL for the Cloud Pub/Sub service. This option is mostly useful for testing via the Pub/Sub emulator. The default value is &quot;https://pubsub.googleapis.com&quot; . :finch - The name of the Finch pool. If no name is provided, then a default pool will be started by the pipeline's supervisor. The default value is nil . Custom token generator A custom token generator can be given as a MFArgs tuple. For example, define a MyApp.fetch_token/0 function: defmodule MyApp do @scope &quot;https://www.googleapis.com/auth/pubsub&quot; def fetch_token ( ) do with { :ok , token } &lt;- Goth.Token . for_scope ( @scope ) { :ok , token . token } end end end and configure the producer to use it: token_generator : { MyApp , :fetch_token , [ ] } Acknowledgements You can use the :on_success and :on_failure options to control how messages are acknowledged with the Pub/Sub system. By default successful messages are acknowledged and failed messages are ignored. You can set :on_success and :on_failure when starting this producer, or change them for each message through Broadway.Message.configure_ack/2 . The following values are supported by both :on_success and :on_failure : :ack - Acknowledge the message. Pub/Sub can remove the message from the subscription. :noop - Do nothing. No requests will be made to Pub/Sub, and the message will be rescheduled according to the subscription-level ackDeadlineSeconds . :nack - Make a request to Pub/Sub to set ackDeadlineSeconds to 0 , which may cause the message to be immediately redelivered to another connected consumer. Note that this does not modify the subscription-level ackDeadlineSeconds used for subsequent messages. {:nack, integer} - Modifies the ackDeadlineSeconds for a particular message. Note that this does not modify the subscription-level ackDeadlineSeconds used for subsequent messages. Batching Even if you are not interested in working with Broadway batches via the handle_batch/3 callback, we recommend all Broadway pipelines with Pub/Sub producers to define a default batcher with batch_size set to 10, so messages can be acknowledged in batches, which improves the performance and reduces the cost of integrating with Google Cloud Pub/Sub. In addition, you should ensure that batch_timeout is set to a value less than the acknowledgement deadline on the subscription. Otherwise you could potentially have messages that remain in the subscription and are never acknowledged successfully. Example Broadway . start_link ( MyBroadway , name : MyBroadway , producer : [ module : { BroadwayCloudPubSub.Producer , subscription : &quot;projects/my-project/subscriptions/my_subscription&quot; } ] , processors : [ default : [ ] ] , batchers : [ default : [ batch_size : 10 , batch_timeout : 2_000 ] ] ) The above configuration will set up a producer that continuously receives messages from &quot;projects/my-project/subscriptions/my_subscription&quot; and sends them downstream. Telemetry This producer emits a few Telemetry events which are listed below. [:broadway_cloud_pub_sub, :pull_client, :pull_request, :start | :stop | :exception] spans - these events are emitted in &quot;span style&quot; when executing pull requests to GCP PubSub. See :telemetry.span/3 . All these events have the measurements described in :telemetry.span/3 . The events contain the following metadata: :max_messages - the number of messages requested after applying the max_messages config option to the existing demand :demand - the total demand accumulated into the producer :name - the name of the Broadway topology [:broadway_cloud_pub_sub, :pull_client, :ack, :start | :stop | :exception] span - these events are emitted in &quot;span style&quot; when acking messages on GCP PubSub. See :telemetry.span/3 . All these events have the measurements described in :telemetry.span/3 . The events contain the following metadata: :name - the name of the Broadway topology","ref":"BroadwayCloudPubSub.Producer.html","title":"BroadwayCloudPubSub.Producer","type":"module"},{"doc":"A subscriptions pull client built on Finch .","ref":"BroadwayCloudPubSub.PullClient.html","title":"BroadwayCloudPubSub.PullClient","type":"module"},{"doc":"A Google Cloud Pub/Sub connector for Broadway . Documentation can be found at https://hexdocs.pm/broadway_cloud_pub_sub . This project provides: BroadwayCloudPubSub.Producer - A GenStage producer that continuously receives messages from a Pub/Sub subscription acknowledges them after being successfully processed. BroadwayCloudPubSub.Client - A generic behaviour to implement Pub/Sub clients. BroadwayCloudPubSub.GoogleApiClient - Default REST client used by BroadwayCloudPubSub.Producer .","ref":"readme.html","title":"BroadwayCloudPubSub","type":"extras"},{"doc":"Add :broadway_cloud_pub_sub to the list of dependencies in mix.exs : def deps do [ { :broadway_cloud_pub_sub , &quot;~&gt; 0.7.0&quot; } , { :goth , &quot;~&gt; 1.0&quot; } ] end Note the goth package, which handles Google Authentication, is required for the default token generator.","ref":"readme.html#installation","title":"BroadwayCloudPubSub - Installation","type":"extras"},{"doc":"Configure Broadway with one or more producers using BroadwayCloudPubSub.Producer : Broadway . start_link ( MyBroadway , name : MyBroadway , producer : [ module : { BroadwayCloudPubSub.Producer , subscription : &quot;projects/my-project/subscriptions/my-subscription&quot; } ] )","ref":"readme.html#usage","title":"BroadwayCloudPubSub - Usage","type":"extras"},{"doc":"Copyright 2019 Michael Crumm Copyright 2020 Dashbit Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"BroadwayCloudPubSub - License","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This version moves Cloud PubSub from Tesla to Finch, so read the notes below and upgrade with care. Added Use :finch as the HTTP client and provide a :finch producer option for a user-defined HTTP pool Make HTTP requests in a separate process for cleaner shutdown Support multiple topologies from the same Brodway module Add telemetry events around HTTP requests Add :deliveryAttempt field to metadata Removed The :pool_size option has been removed. Define your own Finch pool and use the :finch option instead. For example, if your :pool_size was 10, then add Finch to your application supervision tree (usually located in lib/my_app/application.ex ): children = [ { Finch , name : MyFinch , pools : %{ :default =&gt; [ size : 10 ] } } ] ...and wherever you invoke Broadway.start_link/2 , replace this: producer : [ module : { BroadwayCloudPubSub.Producer , subscription : &quot;projects/&lt;your-project-id&gt;/subscriptions/&lt;your-subscription-id&gt;&quot; , pool_size : 10 } ] ...with this: producer : [ module : { BroadwayCloudPubSub.Producer , subscription : &quot;projects/&lt;your-project-id&gt;/subscriptions/&lt;your-subscription-id&gt;&quot; , finch : MyFinch } ]","ref":"changelog.html#0-8-0-2022-10-26","title":"Changelog - [0.8.0] - 2022-10-26","type":"extras"},{"doc":"Added Add :receive_timeout option","ref":"changelog.html#0-7-1-2022-05-09","title":"Changelog - 0.7.1 - 2022-05-09","type":"extras"},{"doc":"Changed Require Broadway 1.0","ref":"changelog.html#0-7-0-2021-08-30","title":"Changelog - 0.7.0 - 2021-08-30","type":"extras"},{"doc":"Changed Remove sensitive details from error log messages Added A new :middleware option to pass a list of custom Tesla middleware Failures to ack are now automatically retried. Retries can be customised via the new :retry option","ref":"changelog.html#0-6-3-2021-07-19","title":"Changelog - 0.6.3 - 2021-07-19","type":"extras"},{"doc":"Changed Fixed a bug causing malformed acknowledgement requests (#54)","ref":"changelog.html#0-6-2-2021-02-24","title":"Changelog - 0.6.2 - 2021-02-24","type":"extras"},{"doc":"Changed Decreased maximum number of ackIds per request (#49)","ref":"changelog.html#0-6-1-2021-02-23","title":"Changelog - 0.6.1 - 2021-02-23","type":"extras"},{"doc":"Added Support for passing a tuple for the scope option Changed Require Broadway v0.6.0","ref":"changelog.html#0-6-0-2020-02-18","title":"Changelog - 0.6.0 - 2020-02-18","type":"extras"},{"doc":"Added Client options for connection pools (#37) Support for configuring acknowledgement behavior (#36) Changed Move acknowledger behaviour from GoogleApiClient into ClientAcknowledger (#39)","ref":"changelog.html#0-5-0-2019-11-06","title":"Changelog - 0.5.0 - 2019-11-06","type":"extras"},{"doc":"Changed Move to Plataformatec GitHub organization and become an official Broadway connector Rename behaviour RestClient to Client (#23) Use hackney as the default adapter (#20) Require Broadway 0.4.x and (optionally) Goth 1.x (#26) Replace :token_module option with :token_generator (#29) Hide handle_receive_messages function that was accidentally made public","ref":"changelog.html#0-4-0-2019-08-19","title":"Changelog - 0.4.0 - 2019-08-19","type":"extras"},{"doc":"Changed BREAKING: The PubsubMessage struct now gets unpacked into the %Broadway.Message{} received in your pipeline. If you were using message.data.data before, you can now use message.data . Additional properties from the PubsubMessage can be found in the message metadata, for instance: message.metadata.attributes or message.metadata.messageId . Requires :broadway ~&gt; 0.3.0","ref":"changelog.html#0-3-0-2019-05-08","title":"Changelog - 0.3.0 - 2019-05-08","type":"extras"},{"doc":"Changed Fixed BroadwayCloudPubSub.GoogleApiClient attempting to send an empty acknowledge request.","ref":"changelog.html#0-1-3-2019-05-06","title":"Changelog - 0.1.3 - 2019-05-06","type":"extras"},{"doc":"Changed MIX_ENV for publishing releases to Hex.","ref":"changelog.html#0-1-2-2019-04-11","title":"Changelog - 0.1.2 - 2019-04-11","type":"extras"},{"doc":"Added This CHANGELOG file to hopefully serve as an evolving example of a standardized open source project CHANGELOG . Changed Fixed CircleCI build for publishing docs to Hex.","ref":"changelog.html#0-1-1-2019-04-11","title":"Changelog - 0.1.1 - 2019-04-11","type":"extras"},{"doc":"Added BroadwayCloudPubSub.Producer - A GenStage producer that continuously receives messages from a Pub/Sub subscription acknowledges them after being successfully processed. BroadwayCloudPubSub.RestClient - A generic behaviour to implement Pub/Sub clients using the REST API . BroadwayCloudPubSub.GoogleApiClient - Default REST client used by BroadwayCloudPubSub.Producer . BroadwayCloudPubSub.Token - A generic behaviour to implement token authentication for Pub/Sub clients. BroadwayCloudPubSub.GothToken - Default token provider used by BroadwayCloudPubSub.Producer .","ref":"changelog.html#0-1-0-2019-04-10","title":"Changelog - 0.1.0 - 2019-04-10","type":"extras"}]